gamerule commandblockoutput false
gamerule sendcommandfeedback false

scoreboard objectives add hp_activate dummy
scoreboard objectives add hp_arrow dummy
scoreboard objectives add hp_select dummy
scoreboard objectives add arrow_away dummy
scoreboard objectives add rayDespawn dummy
scoreboard objectives add voice_spell dummy

scoreboard players add @a hp_arrow 0
scoreboard players add @a hp_activate 0
scoreboard players add @a hp_select 0
scoreboard players add @a arrow_away 0
scoreboard players add @e rayDespawn 0
scoreboard players add @a voice_spell 0

scoreboard players set @a[scores={hp_arrow=3..}] hp_arrow 1
scoreboard players set @a[scores={hp_arrow=..-2}] hp_arrow 1
scoreboard players remove @e[scores={rayDespawn=!0}] rayDespawn 1
event entity @e[scores={rayDespawn=0}] despawn
scoreboard players remove @a[scores={hp_select=0,arrow_away=!0}] arrow_away 1
scoreboard players set @a[scores={hp_select=!0}] arrow_away 150
scoreboard players set @a[scores={hp_activate=3..}] hp_activate 0
scoreboard players remove @a[scores={voice_spell=!0}] voice_spell 1

#Arrows
replaceitem entity @a[scores={hp_arrow=1}] slot.hotbar 8 hp:hp_next 1 0 {"minecraft:keep_on_death":{}}
replaceitem entity @a[scores={hp_arrow=1}] slot.hotbar 7 hp:hp_back 1 0 {"minecraft:keep_on_death":{}}
title @a[scores={hp_select=0,hp_arrow=1,arrow_away=!0}] actionbar §7[§6Arrows: On§7]
clear @a[scores={hp_arrow=0}] hp:hp_back
clear @a[scores={hp_arrow=0}] hp:hp_next

scoreboard players set @a[scores={hp_select=6..}] hp_select 0
scoreboard players set @a[scores={hp_select=-1}] hp_select 5
#End of Arrows

#Spell Setups
scoreboard objectives add hp_spell_1 dummy
scoreboard objectives add hp_spell_2 dummy
scoreboard objectives add hp_spell_3 dummy
scoreboard objectives add hp_spell_4 dummy
scoreboard objectives add hp_spell_5 dummy

scoreboard players add @a hp_spell_1 0
scoreboard players add @a hp_spell_2 0
scoreboard players set @a hp_spell_3 1
scoreboard players set @a hp_spell_4 1
scoreboard players set @a hp_spell_5 1
#End of Spell Setups

#Spell titles
title @a[scores={hp_select=1,hp_spell_3=1,spell_3_cooldown=0}] actionbar §7[§4Basic Cast§7]
title @a[scores={hp_select=1,hp_spell_3=1,spell_3_cooldown=!0}] actionbar §7[§0Basic Cast§7]
title @a[scores={hp_select=1,hp_spell_3=!1}] actionbar §7[§6Undiscovered§7]

title @a[scores={hp_select=2,hp_spell_4=1,spell_4_cooldown=0}] actionbar §7[§bProtego§7]
title @a[scores={hp_select=2,hp_spell_4=1,spell_4_cooldown=!0}] actionbar §7[§0Protego§7]
title @a[scores={hp_select=2,hp_spell_4=!1}] actionbar §7[§6Undiscovered§7]

title @a[scores={hp_select=3,hp_spell_5=1,spell_5_cooldown=0}] actionbar §7[§rStupefy§7]
title @a[scores={hp_select=3,hp_spell_5=1,spell_4_cooldown=!0}] actionbar §7[§0Stupefy§7]
title @a[scores={hp_select=3,hp_spell_5=!1}] actionbar §7[§6Undiscovered§7]

title @a[scores={hp_select=4,hp_spell_1=1}] actionbar §7[§4Expelliarmus§7]
title @a[scores={hp_select=4,hp_spell_1=!1}] actionbar §7[§6Undiscovered§7]

title @a[scores={hp_select=5,hp_spell_2=1}] actionbar §o§l§7[§2Avada Kedavra§7]
title @a[scores={hp_select=5,hp_spell_2=!1}] actionbar §7[§6Undiscovered§7]
#End of Spell titles

#Spells

#Expelliarmus
execute @e[type=hp:spell_1] ~ ~ ~ particle hp:spell_1 ~ ~ ~
execute @e[type=hp:spell_1] ~ ~ ~ particle hp:spell_1_2 ~ ~ ~
execute @e[type=hp:spell_1] ~ ~ ~ particle hp:spell_1_3 ~ ~ ~
execute @e[type=hp:spell_1] ~ ~ ~ particle hp:spell_1_4 ~ ~ ~
execute @e[type=hp:spell_1] ~ ~ ~  kill @e[tag=spell_beam,rm=0.1,r=0.1]
scoreboard players remove @a[scores={spell_1_sound=!0}] spell_1_sound 1
scoreboard objectives add spell_1_sound dummy
scoreboard players add @a spell_1_sound 0
#End of Expelliarmus

#Avada Kedavra
execute @e[type=hp:spell_2] ~ ~ ~ particle hp:spell_2 ~ ~ ~
execute @e[type=hp:spell_2] ~ ~ ~ particle hp:spell_2_2 ~ ~ ~
execute @e[type=hp:spell_2] ~ ~ ~ particle hp:spell_2_3 ~ ~ ~
execute @e[type=hp:spell_2] ~ ~ ~ particle hp:spell_2_4 ~ ~ ~
execute @e[type=hp:spell_2] ~ ~ ~  kill @e[tag=spell_beam,rm=0.1,r=0.1]
scoreboard players remove @a[scores={spell_1_sound=!0}] spell_1_sound 1

tag @e[type=hp:spell_1] add spell_beam
tag @e[type=hp:spell_2] add spell_beam

execute @e[tag=spell_beam] ~ ~ ~ scoreboard players set @e[tag=spell_beam,rm=0.5,r=1.5] beam_on 3
scoreboard objectives add beam_on dummy
scoreboard players add @e[tag=spell_beam] beam_on 0
scoreboard players remove @e[scores={beam_on=!..1}] beam_on 1
event entity @e[scores={beam_on=1}] despawn

execute @e[type=hp:spell_1] ~ ~ ~ execute @e[r=1.5,type=hp:spell_2] ~ ~ ~ execute @s ~ ~ ~ tp @s ~ ~ ~
execute @e[type=hp:spell_2] ~ ~ ~ execute @e[r=1.5,type=hp:spell_1] ~ ~ ~ execute @s ~ ~ ~ tp @s ~ ~ ~
#End of Avada Kedavra

#Basic Cast
execute @e[type=hp:spell_3] ~ ~ ~ particle hp:spell_1 ~ ~ ~
execute @e[type=hp:spell_3] ~ ~ ~ particle hp:spell_1_2 ~ ~ ~
execute @e[type=hp:spell_3] ~ ~ ~ particle hp:spell_1_3 ~ ~ ~
execute @e[type=hp:spell_3] ~ ~ ~ particle hp:spell_1_4 ~ ~ ~
scoreboard objectives add spell_3_cooldown dummy
scoreboard players add @a spell_3_cooldown 0
scoreboard players remove @a[scores={spell_3_cooldown=!0}] spell_3_cooldown 1
#End of basic cast

#Protego
execute @a[tag=protego] ~ ~ ~ particle hp:spell_4 ~ ~0.5 ~

execute @e[tag=!protego,type=!hp:spell_4] ~ ~ ~ execute @s ~ ~ ~ detect ^ ^ ^-1 air 0 tp @s ^ ^ ^-0.8 facing @e[type=hp:spell_4,r=2,c=1]
tag @a[scores={spell_4_cooldown=0}] remove protego
scoreboard objectives add spell_4_cooldown dummy
scoreboard players add @a spell_4_cooldown 0
scoreboard players remove @a[scores={spell_4_cooldown=!0}] spell_4_cooldown 1
#End of Protego

#stupefy
execute @e[type=hp:spell_5] ~ ~ ~ particle hp:spell_5_2 ~ ~ ~
scoreboard objectives add spell_5_cooldown dummy
scoreboard players add @a spell_5_cooldown 0
scoreboard players remove @a[scores={spell_5_cooldown=!0}] spell_5_cooldown 1

#End of Spells
